package aaf.capitulo14.s140210;

public class Fecha
{
	private int dia;
	private int mes;
	private int anio;

	private int fechaToDias()
	{
		// no requiere demasiada explicacion...
		return anio*360+mes*30+dia;
	}

	// asigna la fecha expresada en dias a los atributos
	private void diasToFecha(int i)
	{
		// dividimos por 360 y obtenemos el ao
		anio=(int)i/360;
		// del resto o residuo de la division anterior
		// podremos obtener el mes y el dia
		int resto=i%360;
		// el mes es el resto dividido 30
		mes=(int)resto/30;
		// el resto de la division anterior son los dias
		dia=resto%30;
		// ajuste por si el dia quedo en cero
		if(dia==0)
		{
			dia=30;
			mes--;
		}
		// ajuste por si el mes quedo en cero
		if(mes==0)
		{
			mes=12;
			anio--;
		}
	}

	public void addDias(int d)
	{
		// convertimos la fecha a dias y le sumamos d
		int sum=fechaToDias()+d;
		// la fecha resultante (sum) se separa en dia, mes y ao
		diasToFecha(sum);
	}

	public Fecha(int d,int m,int a)
	{
		this.dia=d;
		this.mes=m;
		this.anio=a;
	}

	// constructor sin argumentos
	public Fecha()
	{
	}

	public Fecha(String s)
	{
		// buscamos la primera ocurrencia de '/'
		int pos1=s.indexOf('/');

		// buscamos la ultima ocurrencia de '/'
		int pos2=s.lastIndexOf('/');

		// procesamos el dia
		String sDia=s.substring(0,pos1);
		dia=Integer.parseInt(sDia);

		// procesamos el mes
		String sMes=s.substring(pos1+1,pos2);
		mes=Integer.parseInt(sMes);

		// procesamos el anio
		String sAnio=s.substring(pos2+1);
		anio=Integer.parseInt(sAnio);
	}

	// sobrescribimos el metodo equals que heredamos de Object
	public boolean equals(Object o)
	{
		Fecha otra=(Fecha)o;
		return (dia==otra.dia)&&(mes==otra.mes)&&(anio==otra.anio);
	}

	@Override
	public String toString()
	{
		return dia+"/"+mes+"/"+anio;
	}

	public int getDia()
	{
		return dia;
	}

	public void setDia(int dia)
	{
		this.dia=dia;
	}

	public int getMes()
	{
		return mes;
	}

	public void setMes(int mes)
	{
		this.mes=mes;
	}

	public int getAnio()
	{
		return anio;
	}

	public void setAnio(int anio)
	{
		this.anio=anio;
	}

}